org.apache.commons.math3.distribution

## Class FDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.FDistribution

All Implemented Interfaces:
  java.io.Serializable, RealDistribution

    public class FDistribution
    extends AbstractRealDistribution

Implementation of the F-distribution.

Version:
  $Id: FDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  F-distribution (Wikipedia), F-distribution (MathWorld), Serialized Form

### Field Summary

Fields
`static double` `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.
`private double` `denominatorDegreesOfFreedom` The numerator degrees of freedom.
`private double` `numeratorDegreesOfFreedom` The numerator degrees of freedom.
`private double` `numericalVariance` Cached numerical variance
`private boolean` `numericalVarianceIsCalculated` Whether or not the numerical variance has been calculated
`private static long` `serialVersionUID` Serializable version identifier.
`private double` `solverAbsoluteAccuracy` Inverse cumulative probability accuracy.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

### Constructor Summary

Constructors
Constructor and Description
`FDistribution(double numeratorDegreesOfFreedom, double denominatorDegreesOfFreedom)` Creates an F distribution using the given degrees of freedom.
`FDistribution(double numeratorDegreesOfFreedom, double denominatorDegreesOfFreedom, double inverseCumAccuracy)` Creates an F distribution using the given degrees of freedom and inverse cumulative probability accuracy.
`FDistribution(RandomGenerator rng, double numeratorDegreesOfFreedom, double denominatorDegreesOfFreedom, double inverseCumAccuracy)` Creates an F distribution.

### Method Summary

Methods
`protected double` `calculateNumericalVariance()` used by `getNumericalVariance()`
`double` `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double` `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double` `getDenominatorDegreesOfFreedom()` Access the denominator degrees of freedom.
`double` `getNumeratorDegreesOfFreedom()` Access the numerator degrees of freedom.
`double` `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`protected double` `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
`double` `getSupportLowerBound()` Access the lower bound of the support.
`double` `getSupportUpperBound()` Access the upper bound of the support.
`boolean` `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`boolean` `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
`boolean` `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

Default inverse cumulative probability accuracy.

Since:
  2.1
See Also:
  Constant Field Values

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### numeratorDegreesOfFreedom

    private final double numeratorDegreesOfFreedom

The numerator degrees of freedom.

#### denominatorDegreesOfFreedom

    private final double denominatorDegreesOfFreedom

The numerator degrees of freedom.

#### solverAbsoluteAccuracy

    private final double solverAbsoluteAccuracy

Inverse cumulative probability accuracy.

#### numericalVariance

    private double numericalVariance

Cached numerical variance

#### numericalVarianceIsCalculated

    private boolean numericalVarianceIsCalculated

Whether or not the numerical variance has been calculated

### Constructor Detail

#### FDistribution

    public FDistribution(double numeratorDegreesOfFreedom,
                 double denominatorDegreesOfFreedom)
                  throws NotStrictlyPositiveException

Creates an F distribution using the given degrees of freedom.

Parameters:
  `numeratorDegreesOfFreedom` - Numerator degrees of freedom.
  `denominatorDegreesOfFreedom` - Denominator degrees of freedom.
Throws:
  `NotStrictlyPositiveException` - if `numeratorDegreesOfFreedom <= 0` or `denominatorDegreesOfFreedom <= 0`.

#### FDistribution

    public FDistribution(double numeratorDegreesOfFreedom,
                 double denominatorDegreesOfFreedom,
                 double inverseCumAccuracy)
                  throws NotStrictlyPositiveException

Creates an F distribution using the given degrees of freedom and inverse cumulative probability accuracy.

Parameters:
  `numeratorDegreesOfFreedom` - Numerator degrees of freedom.
  `denominatorDegreesOfFreedom` - Denominator degrees of freedom.
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates.
Throws:
  `NotStrictlyPositiveException` - if `numeratorDegreesOfFreedom <= 0` or `denominatorDegreesOfFreedom <= 0`.
Since:
  2.1

#### FDistribution

    public FDistribution(RandomGenerator rng,
                 double numeratorDegreesOfFreedom,
                 double denominatorDegreesOfFreedom,
                 double inverseCumAccuracy)
                  throws NotStrictlyPositiveException

Creates an F distribution.

Parameters:
  `rng` - Random number generator.
  `numeratorDegreesOfFreedom` - Numerator degrees of freedom.
  `denominatorDegreesOfFreedom` - Denominator degrees of freedom.
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates.
Throws:
  `NotStrictlyPositiveException` - if `numeratorDegreesOfFreedom <= 0` or `denominatorDegreesOfFreedom <= 0`.
Since:
  3.1

### Method Detail

#### density

    public double density(double x)

Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`
Since:
  2.1

#### cumulativeProbability

    public double cumulativeProbability(double x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution. The implementation of this method is based on

- F-Distribution, equation (4).

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

#### getNumeratorDegreesOfFreedom

    public double getNumeratorDegreesOfFreedom()

Access the numerator degrees of freedom.

Returns:
  the numerator degrees of freedom.

#### getDenominatorDegreesOfFreedom

    public double getDenominatorDegreesOfFreedom()

Access the denominator degrees of freedom.

Returns:
  the denominator degrees of freedom.

#### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the maximum absolute error in inverse cumulative probability estimates

#### getNumericalMean

    public double getNumericalMean()

Use this method to get the numerical value of the mean of this distribution. For denominator degrees of freedom parameter `b`, the mean is

- if `b > 2` then `b / (b - 2)`,
- else undefined (`Double.NaN`).

Returns:
  the mean or `Double.NaN` if it is not defined

#### getNumericalVariance

    public double getNumericalVariance()

Use this method to get the numerical value of the variance of this distribution. For numerator degrees of freedom parameter `a` and denominator degrees of freedom parameter `b`, the variance is

- if `b > 4` then `[2 * b^2 * (a + b - 2)] / [a * (b - 2)^2 * (b - 4)]`,
- else undefined (`Double.NaN`).

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

#### calculateNumericalVariance

    protected double calculateNumericalVariance()

used by `getNumericalVariance()`

Returns:
  the variance of this distribution

#### getSupportLowerBound

    public double getSupportLowerBound()

Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X <= x) > 0}`.

The lower bound of the support is always 0 no matter the parameters.

Returns:
  lower bound of the support (always 0)

#### getSupportUpperBound

    public double getSupportUpperBound()

Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X <= x) = 1}`.

The upper bound of the support is always positive infinity no matter the parameters.

Returns:
  upper bound of the support (always Double.POSITIVE_INFINITY)

#### isSupportLowerBoundInclusive

    public boolean isSupportLowerBoundInclusive()

Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportUpperBoundInclusive

    public boolean isSupportUpperBoundInclusive()

Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportConnected

    public boolean isSupportConnected()

Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`